import java.io.IOException;
import java.util.HashMap;

import javax.sound.midi.InvalidMidiDataException;
import javax.sound.midi.MetaEventListener;
import javax.sound.midi.MetaMessage;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;
import javax.sound.midi.Receiver;
import javax.sound.midi.Sequence;
import javax.sound.midi.Sequencer;
import javax.sound.midi.Synthesizer;
import javax.sound.midi.Transmitter;

/*
 * Created on 2006/11/05
 */

public class MkMidi implements MetaEventListener {
    // ĐI^Cxg
    private static final int END_OF_TRACK = 47;

    // V[PT[
    static private Sequencer sequencer;
    // VZTCU[
    static private Synthesizer synthesizer;

    // o^łMIDIt@C̍ő吔
    static private int maxSequences;
    // MIDIt@Cf[^iO->Sequencej
    static private HashMap midiMap;
    // o^ĂMIDIt@C
    static private int counter = 0;

    // ݍĐMIDIV[PX
    static String currentSequenceName = "";

    /**
     * RXgN^
     */
    public MkMidi() {}

    /**
     * RXgN^
     * 
     * @param maxSequences
     *            o^łMIDIt@C̍ő吔
     * @return 
     */
    public static void Initialize(int MaxSequences) {
        maxSequences = MaxSequences;
        midiMap = new HashMap(maxSequences);

        // V[PT[ƃVZTCU[
        initSequencer();
    }

    private static void initSequencer() {
        try {
            // V[PTJ
            sequencer = MidiSystem.getSequencer();
            sequencer.open();
            // ^CxgXi[o^
            sequencer.addMetaEventListener(new MkMidi());
            // V[PTƃVZTCU[̐ڑ
            if (!(sequencer instanceof Synthesizer)) { // J2SE 5.0p
                // VZTCU[J
                synthesizer = MidiSystem.getSynthesizer();
                synthesizer.open();
                Receiver synthReceiver = synthesizer.getReceiver();
                Transmitter seqTransmitter = sequencer.getTransmitter();
                seqTransmitter.setReceiver(synthReceiver);
            } else { // J2SE 1.4.2ȑO
                // V[PTƃVZTCU[͓
                synthesizer = (Synthesizer) sequencer;
            }
        } catch (MidiUnavailableException e) {
            e.printStackTrace();
        }
    }

    /**
     * MIDIt@C[h
     * 
     * @param name
     *            o^
     * @param filename
     *            t@C
     */
	@SuppressWarnings("unchecked")
	public void load(String name, String filename) {
        if (counter == maxSequences) {
            System.out.println("G[: ȏo^ł܂");
            return;
        }

        try {
            // MIDIt@C[h
            Sequence seq = MidiSystem.getSequence(getClass().getResource(
                    filename));
            // o^
            midiMap.put(name, seq);
        } catch (InvalidMidiDataException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /**
     * Đ
     * 
     * @param name
     *            o^
     */
    public void play(String name) {
        // ݍĐ̃V[PXƓȂ牽Ȃ
        if (currentSequenceName.equals(name)) {
            return;
        }

        // ݍĐ̃V[PX~
        stop();

        // OɑΉMIDI擾
        Sequence seq = (Sequence)midiMap.get(name);  // MIDIV[PX
        if (sequencer != null && seq != null) {
            try {
                sequencer.setSequence(seq);  // V[PTɃZbg
                sequencer.start();  // ĐJnI
                currentSequenceName = name;
            } catch (InvalidMidiDataException e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * ~
     */
    public void stop() {
        if (sequencer.isRunning()) {
            sequencer.stop();
        }
    }

    /**
     * I
     */
    public void close() {
        // Đ̃V[PX~
        stop();

        // V[PT̏I
        sequencer.removeMetaEventListener(this);
        sequencer.close();
        sequencer = null;
    }

    public void meta(MetaMessage meta) {
        // ĐIꍇ
        if (meta.getType() == END_OF_TRACK) {
            if (sequencer != null && sequencer.isOpen()) {
                // MIDIV[PXĐʒuɖ߂
                sequencer.setMicrosecondPosition(0);
                // ŏĐ
                sequencer.start();
            }
        }
    }
}
